using System;
using System.Text;
using System.Threading;
using System.Collections;
using System.Net;
using System.Net.Sockets;
using System.Runtime.CompilerServices;
using Microsoft.SPOT.Drivers.Digi.GPIO;
using Microsoft.SPOT.Hardware;

namespace Microsoft.SPOT.Samples.Digi.ConnectME.SerialSocketGPIO
{
    public class LEDSample
    {
        private static long DottedDecimalToIp(byte a1, byte a2, byte a3, byte a4)
        {
            return (long)((ulong)a4 << 24 | (ulong)a3 << 16 | (ulong)a2 << 8 | (ulong)a1); 
        }

        static void Main(string[] args)
        {
            //Socket socketServer;
            //Socket s;

            const bool GLITCH_FILTER_NONE = false;
            byte[] SocketBuffer = new byte[100];
            string SocketMessage = string.Empty;
            Encoding StringEncoder = Encoding.UTF8;
            Socket SocketClient;
            IPEndPoint ServerIPEndPoint = new IPEndPoint(DottedDecimalToIp(192,168,101,200),80);

            SocketClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            try
            {
                SocketClient.Connect(ServerIPEndPoint);
            }
            catch
            {
                Debug.Print("Unable to connect to socket server");
            }
            SocketMessage = DateTime.Now.ToString("HH:mm:ss");
            SocketMessage += " .NET Micro Framework socket client connected.\r\n";
            Debug.Print(SocketMessage);
            SocketBuffer = StringEncoder.GetBytes(SocketMessage);
            SocketClient.Send(SocketBuffer,SocketFlags.None);

            byte[] buff = new byte[100];
            byte[] buff2 = new byte[100];
            //string StdReply = "Digi Connect ME and .NET Micro Framework\r\n";
            //string ChangeReply = "*** Network notification: GPIO change detected\r\n";

            //socketServer = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            //socketServer.Bind(new IPEndPoint(DottedDecimalToIp(10,52,32,2), 80));
            //socketServer.Bind(new IPEndPoint(DottedDecimalToIp(192, 168, 101, 100), 80));
            //socketServer.Listen(1);
            //Debug.Print("Sockets Server Started");
            
            //for (int strcnt = 0; strcnt < StdReply.Length; strcnt++)
            //    buff[strcnt] = (byte)StdReply[strcnt];
            //for (int strcnt = 0; strcnt < ChangeReply.Length; strcnt++)
            //    buff2[strcnt] = (byte)ChangeReply[strcnt];

            //BlinkingLed l = new BlinkingLed((Cpu.Pin)0, true);
            //InputPort gpio = new InputPort((Cpu.Pin)0, false, Port.ResistorMode.PullUp);
            InterruptPort gpio = new InterruptPort((Cpu.Pin)0, GLITCH_FILTER_NONE, Port.ResistorMode.PullUp, Port.InterruptMode.InterruptEdgeBoth);
            
            //l.On = false;

            //l.Blink(200);
            bool OldState = false, NewState = true;
            while (true) {
                NewState = gpio.Read();
                if ((false == OldState) || (OldState != NewState)) {
                    if (true == NewState)
                    {
                        Debug.Print("Digi Connect ME and\r\n.NET Micro Framework");
            //            s = socketServer.Accept();
            //            s.Send(buff, buff.Length, SocketFlags.None);
                    }
                    else if (true == OldState)
                    {
                        Debug.Print("Serial notification:\r\nGPIO Change Detected");
            //            s = socketServer.Accept();
            //            s.Send(buff2, buff2.Length, SocketFlags.None);
                    }
                    OldState = NewState;
                }
                Thread.Sleep(100);
            }
        }
    }
}
