using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace SocketClient
{
    public partial class Form1 : Form
    {
        IPAddress m_ip;
        int m_port;
        Socket m_sock = null;
        Thread m_rcvTh;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (m_sock != null)
            {
                m_sock.Disconnect(false);
                m_sock = null;

                m_rcvTh.Abort();
                m_rcvTh.Join();
                m_rcvTh = null;
            }
            try
            {
                m_ip = IPAddress.Parse(textBox1.Text);
            }
            catch
            {
                MessageBox.Show("Invalid IP address");
                textBox1.Text = "";
                return;
            }
            try
            {
                m_port = int.Parse(textBox2.Text);
            }
            catch
            {
                MessageBox.Show("Invalid Port number");
                textBox2.Text = "";
                return;
            }

            try
            {
                m_sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                m_sock.Connect(m_ip, m_port);

                m_rcvTh = new Thread(new ThreadStart(RecvThread));
                m_rcvTh.Start();

                button1.Enabled = false;
                button3.Enabled = true;
            }
            catch(Exception ex)
            {
                m_sock = null;
                MessageBox.Show("Unable to connect to " + m_ip.ToString());
            }

        }

        private void RecvThread()
        {
            byte []data = new byte[100];
            while (true)
            {
                StringBuilder sb = new StringBuilder();
                try
                {
                    //MessageBox.Show("Waiting for packet"); 
                    int len = m_sock.Receive(data);
                    //MessageBox.Show("got a packet");
                    if (len > 0)
                    {
                        for (int i = 0; i < len; i++)
                        {
                            sb.Append((char)data[i]);
                        }
                        richTextBox1.Invoke((MethodInvoker)delegate
                        {
                            richTextBox1.AppendText(sb.ToString());
                        });
                    }
                    else
                    {
                        //break;
                    }
                    m_sock.Shutdown(SocketShutdown.Both);
                    m_sock.Close();
                    m_sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                    m_sock.Connect(m_ip, m_port);
                }                
                catch
                {
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (m_sock != null)
            {
                m_sock.Shutdown(SocketShutdown.Both);
                m_sock.Close();
                m_sock = null;
            }
            
            if (m_rcvTh != null)
            {
                m_rcvTh.Abort();
                m_rcvTh.Join();
                m_rcvTh = null;
            }

            button1.Enabled = true;
            button3.Enabled = false;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            button3_Click(null, null);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
        }

    }
}